diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/AUTHORS ns-3.44/AUTHORS
--- ns-3.43/AUTHORS	2024-10-09 16:41:09.752655300 -0700
+++ ns-3.44/AUTHORS	2025-03-09 16:55:49.223370600 -0700
@@ -25,6 +25,7 @@
 Mirko Banchi (mk.banchi@gmail.com)
 Peter D. Barnes, Jr. (barnes26@llnl.gov)
 Ramon Bauza (monbauza@gmail.com)
+Martin Belanger (martin.belanger@dell.com)
 Pedro Bellotti (pedro177@gmail.com)
 Mehdi Benamor (mehdi.benamor@telecom-bretagne.eu)
 Apoorva Bhargava (apoorvabhargava13@gmail.com)
@@ -48,6 +49,7 @@
 Junling Bu (linlinjavaer@gmail.com)
 Elena Buchatskaia (borovkovaes@iitp.ru)
 Alessio Bugetti (alessiobugetti98@gmail.com)
+Anna-Birgitta Burmeister (anna-birgitta.burmeister@student.hpi.de)
 Nuno Cardoso (nunopcardoso@gmail.com)
 Gustavo Carneiro (gjc@inescporto.pt, gjcarneiro@gmail.com)
 Scott Carpenter (scarpen@ncsu.edu)
@@ -71,6 +73,7 @@
 Luis Cortes (cortes@gatech.edu)
 Luca Costantino (luca.costantino@gmail.com)
 Matthieu Coudron (matthieu.coudron@lip6.fr)
+Michael R. Davis (mrdvt92@yahoo.com)
 Alexander D'souza (moijes12@gmail.com)
 Ankit Deepak (adadeepak8@gmail.com)
 Christophe Delahaye (christophe.delahaye@orange.com)
@@ -152,6 +155,7 @@
 Evgeny Kalishenko (ydginster@gmail.com)
 Raghuram Kannan (raghuramkannan40@gmail.com)
 Vignesh Kannan (vignesh2496@gmail.com)
+Nihar Kapasi (niharkkapasi@gmail.com)
 Ouassim Karrakchou (okarr102@uottawa.ca)
 Tanmay Kathpalia (tanmay.kathpalia@landisgyr.com)
 Konstantinos Katsaros (dinos.katsaros@gmail.com)
@@ -161,10 +165,12 @@
 Morteza Kheirkhah (m.kheirkhah@sussex.ac.uk)
 Jörg Christian Kirchhof (christian.kirchhof@rwth-aachen.de)
 Ohad Klausner
+Yohei Kojima (yk@y-koj.net)
 Wojtek Kosior (koszko@koszko.org)
 Katarina Koutlia (katerina.koutlia@cttc.es)
 Shravya Ks (shravya.ks0@gmail.com)
 Flavio Kubota (flaviokubota@gmail.com)
+Puneet Kumar (puneet23067@iiitd.ac.in)
 Manish Kumar B.(bmanish15597@gmail.com)
 Joe Kopena (tjkopena@cs.drexel.edu)
 Christopher Kosecki (christopher.l.kosecki.ctr@mail.mil)
@@ -300,6 +306,7 @@
 Surya Seetharaman (suryaseetharaman.9@gmail.com)
 Guillaume Seguin (guillaume.seguin@inria.fr)
 Ioannis Selinis (selinis.g@gmail.com)
+Yifan Fan Seu (yifan.fan.seu@gmail.com)
 Tomasz Seweryn (tomasz.seweryn7@gmail.com)
 Dmitrii Shakshin (d.shakshin@gmail.com)
 Kulin Shah (m.kulin@gmail.com)
@@ -369,3 +376,4 @@
 Parth Pratim (GCI 2018)
 ra1nst0rm3d (GCI 2019)
 SaiMyGuy (GCI 2019)
+Ryo Okuda (c611901200@tokushima-u.ac.jp)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/bindings/python/ns__init__.py ns-3.44/bindings/python/ns__init__.py
--- ns-3.43/bindings/python/ns__init__.py	2024-10-09 16:41:09.760655400 -0700
+++ ns-3.44/bindings/python/ns__init__.py	2025-03-09 16:55:49.231370400 -0700
@@ -115,7 +115,7 @@
             library_map[library_infix] = set()
 
         # Append the directory
-        library_map[library_infix].add(library)
+        library_map[library_infix].add(os.path.realpath(library))
 
     # Replace sets with lists
     for key, values in library_map.items():
@@ -251,10 +251,18 @@
             values["NS3_ENABLED_MODULES"] + values["NS3_ENABLED_CONTRIBUTED_MODULES"],
         )
     )
+
     prefix = values["out_dir"]
-    libraries = {
-        os.path.splitext(os.path.basename(x))[0]: x for x in os.listdir(os.path.join(prefix, "lib"))
-    }
+    path_to_lib = None
+    for variant in ["lib", "lib64"]:
+        path_candidate = os.path.join(prefix, variant)
+        if os.path.isdir(path_candidate):
+            path_to_lib = path_candidate
+            break
+    if path_to_lib is None:
+        raise Exception(f"Directory {prefix} does not contain subdirectory lib/ (nor lib64/).")
+    libraries = {os.path.splitext(os.path.basename(x))[0]: x for x in os.listdir(path_to_lib)}
+
     version = values["VERSION"]
 
     # Filter out test libraries and incorrect versions
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/build-support/3rd-party/colored-messages.cmake.license ns-3.44/build-support/3rd-party/colored-messages.cmake.license
--- ns-3.43/build-support/3rd-party/colored-messages.cmake.license	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.44/build-support/3rd-party/colored-messages.cmake.license	2025-03-09 16:55:49.231370400 -0700
@@ -0,0 +1,2 @@
+Copyright (c) 2013 Fraser Hutchison
+SPDX-License-Identifier: GPL-2.0-only
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/build-support/3rd-party/FindEigen3.cmake.license ns-3.44/build-support/3rd-party/FindEigen3.cmake.license
--- ns-3.43/build-support/3rd-party/FindEigen3.cmake.license	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.44/build-support/3rd-party/FindEigen3.cmake.license	2025-03-09 16:55:49.231370400 -0700
@@ -0,0 +1,4 @@
+Copyright (c) 2006, 2007 Montel Laurent, <montel@kde.org>
+Copyright (c) 2008, 2009 Gael Guennebaud, <g.gael@free.fr>
+Copyright (c) 2009 Benoit Jacob <jacob.benoit.1@gmail.com>
+SPDX-License-Identifier: BSD-2-Clause
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/build-support/3rd-party/FindGTK3.cmake.license ns-3.44/build-support/3rd-party/FindGTK3.cmake.license
--- ns-3.43/build-support/3rd-party/FindGTK3.cmake.license	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.44/build-support/3rd-party/FindGTK3.cmake.license	2025-03-09 16:55:49.231370400 -0700
@@ -0,0 +1,4 @@
+Copyright 2009 Kitware, Inc.
+Copyright 2008-2009 Philip Lowman <philip@yhbt.com>
+Copyright 2014-2018 Ettercap Development Team <info@ettercap-project.org>
+SPDX-License-Identifier: BSD-3-Clause
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/build-support/3rd-party/FindHarfBuzz.cmake.license ns-3.44/build-support/3rd-party/FindHarfBuzz.cmake.license
--- ns-3.43/build-support/3rd-party/FindHarfBuzz.cmake.license	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.44/build-support/3rd-party/FindHarfBuzz.cmake.license	2025-03-09 16:55:49.231370400 -0700
@@ -0,0 +1,3 @@
+Copyright (c) 2012, Intel Corporation
+Copyright (c) 2019 Sony Interactive
+SPDX-License-Identifier: BSD-3-Clause
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/build-support/3rd-party/find-program-hints.cmake ns-3.44/build-support/3rd-party/find-program-hints.cmake
--- ns-3.43/build-support/3rd-party/find-program-hints.cmake	2024-10-09 16:41:09.760655400 -0700
+++ ns-3.44/build-support/3rd-party/find-program-hints.cmake	2025-03-09 16:55:49.231370400 -0700
@@ -1,3 +1,9 @@
+# Copyright (c) 2022 Universidade de Brasília
+#
+# SPDX-License-Identifier: GPL-2.0-only
+#
+# Author: Gabriel Ferreira <gabrielcarvfer@gmail.com>
+
 disable_cmake_warnings()
 string(REPLACE ";" "/bin;" syspaths "${CMAKE_SYSTEM_PREFIX_PATH};")
 set(3RD_PARTY_FIND_PROGRAM_HINTS
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/build-support/3rd-party/FindSphinx.cmake.license ns-3.44/build-support/3rd-party/FindSphinx.cmake.license
--- ns-3.43/build-support/3rd-party/FindSphinx.cmake.license	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.44/build-support/3rd-party/FindSphinx.cmake.license	2025-03-09 16:55:49.231370400 -0700
@@ -0,0 +1,3 @@
+Copyright (c) 2014 University of Illinois at Urbana-Champaign
+SPDX-License-Identifier: NCSA
+From llvm.org llvm/cmake/modules/
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/build-support/custom-modules/ns3-compiler-and-linker-support.cmake ns-3.44/build-support/custom-modules/ns3-compiler-and-linker-support.cmake
--- ns-3.43/build-support/custom-modules/ns3-compiler-and-linker-support.cmake	2024-10-09 16:41:09.760655400 -0700
+++ ns-3.44/build-support/custom-modules/ns3-compiler-and-linker-support.cmake	2025-03-09 16:55:49.231370400 -0700
@@ -33,6 +33,10 @@
   if(${NS3_COLORED_OUTPUT} OR "$ENV{CLICOLOR}")
     add_definitions(-fcolor-diagnostics) # colorize clang++ output
   endif()
+  if("${CMAKE_SYSTEM_PROCESSOR}" STREQUAL "aarch64")
+    # see https://gitlab.com/nsnam/ns-3-dev/-/issues/932
+    add_compile_definitions(NVALGRIND)
+  endif()
 endif()
 
 set(GCC FALSE)
@@ -105,7 +109,7 @@
   set(STATIC_LINK_FLAGS "")
 endif()
 
-if(${NS3_FAST_LINKERS})
+if(${NS3_FAST_LINKERS} AND (NOT ${MSVC}))
   # Search for faster linkers mold and lld, and use them if available
   mark_as_advanced(MOLD LLD)
   find_program(MOLD mold)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/build-support/custom-modules/ns3-contributions.cmake ns-3.44/build-support/custom-modules/ns3-contributions.cmake
--- ns-3.43/build-support/custom-modules/ns3-contributions.cmake	2024-10-09 16:41:09.760655400 -0700
+++ ns-3.44/build-support/custom-modules/ns3-contributions.cmake	2025-03-09 16:55:49.231370400 -0700
@@ -15,9 +15,15 @@
   # Add contribution folders to be built
   foreach(contribname ${contribution_list})
     set(folder "contrib/${contribname}")
+    set(external_folder "../ns-3-external-contrib/${contribname}")
     if(EXISTS ${PROJECT_SOURCE_DIR}/${folder}/CMakeLists.txt)
       message(STATUS "Processing ${folder}")
       add_subdirectory(${folder})
+    elseif(EXISTS ${PROJECT_SOURCE_DIR}/${external_folder}/CMakeLists.txt)
+      message(STATUS "Processing ${external_folder}")
+      add_subdirectory(
+        ${external_folder} ${PROJECT_BINARY_DIR}/contrib/${contribname}
+      )
     else()
       message(${HIGHLIGHTED_STATUS}
               "Skipping ${folder} : it does not contain a CMakeLists.txt file"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/build-support/custom-modules/ns3-coverage.cmake ns-3.44/build-support/custom-modules/ns3-coverage.cmake
--- ns-3.43/build-support/custom-modules/ns3-coverage.cmake	2024-10-09 16:41:09.760655400 -0700
+++ ns-3.44/build-support/custom-modules/ns3-coverage.cmake	2025-03-09 16:55:49.231370400 -0700
@@ -27,7 +27,7 @@
   # cmake-cache or cmake-build-${build_suffix}
 
   # Create output directory for coverage info and html
-  file(MAKE_DIRECTORY ${CMAKE_OUTPUT_DIRECTORY}/coverage)
+  make_directory(${CMAKE_OUTPUT_DIRECTORY}/coverage)
 
   # Extract code coverage results and build html report
   add_custom_target(
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/build-support/custom-modules/ns3-executables.cmake ns-3.44/build-support/custom-modules/ns3-executables.cmake
--- ns-3.43/build-support/custom-modules/ns3-executables.cmake	2024-10-09 16:41:09.760655400 -0700
+++ ns-3.44/build-support/custom-modules/ns3-executables.cmake	2025-03-09 16:55:49.231370400 -0700
@@ -17,9 +17,9 @@
     PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${output_directory}
                RUNTIME_OUTPUT_NAME ${ns3-exec-outputname}
   )
-  if(${XCODE})
-    # Is that so hard not to break people's CI, AAPL?? Why would you output the
-    # targets to a Debug/Release subfolder? Why?
+  if(${MSVC} OR ${XCODE})
+    # Prevent multi-config generators from placing output files into per
+    # configuration directory
     foreach(OUTPUTCONFIG ${CMAKE_CONFIGURATION_TYPES})
       string(TOUPPER ${OUTPUTCONFIG} OUTPUTCONFIG)
       set_target_properties(
@@ -137,6 +137,17 @@
     )
   endif()
 
+  # Handle ns-3-external-contrib/module (which will have output binaries mapped
+  # to contrib/module)
+  if(${BEXEC_EXECUTABLE_DIRECTORY_PATH} MATCHES "ns-3-external-contrib")
+    string(
+      REGEX
+      REPLACE ".*ns-3-external-contrib" "${PROJECT_SOURCE_DIR}/build/contrib"
+              BEXEC_EXECUTABLE_DIRECTORY_PATH
+              "${BEXEC_EXECUTABLE_DIRECTORY_PATH}"
+    )
+  endif()
+
   set_runtime_outputdirectory(
     "${BEXEC_EXECNAME}" "${BEXEC_EXECUTABLE_DIRECTORY_PATH}/"
     "${BEXEC_EXECNAME_PREFIX}"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/build-support/custom-modules/ns3-lock.cmake ns-3.44/build-support/custom-modules/ns3-lock.cmake
--- ns-3.43/build-support/custom-modules/ns3-lock.cmake	2024-10-09 16:41:09.764655400 -0700
+++ ns-3.44/build-support/custom-modules/ns3-lock.cmake	2025-03-09 16:55:49.231370400 -0700
@@ -72,6 +72,7 @@
   cache_cmake_flag(NS3_BRITE "ENABLE_BRITE" lock_contents)
   cache_cmake_flag(NS3_ENABLE_SUDO "ENABLE_SUDO" lock_contents)
   cache_cmake_flag(NS3_PYTHON_BINDINGS "ENABLE_PYTHON_BINDINGS" lock_contents)
+  cache_cmake_flag(NS3_NETANIM "FETCH_NETANIM_VISUALIZER" lock_contents)
 
   string(APPEND lock_contents "EXAMPLE_DIRECTORIES = [")
   foreach(example_folder ${ns3-example-folders})
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/build-support/custom-modules/ns3-module-macros.cmake ns-3.44/build-support/custom-modules/ns3-module-macros.cmake
--- ns-3.43/build-support/custom-modules/ns3-module-macros.cmake	2024-10-09 16:41:09.764655400 -0700
+++ ns-3.44/build-support/custom-modules/ns3-module-macros.cmake	2025-03-09 16:55:49.231370400 -0700
@@ -17,7 +17,7 @@
 
     # If output directory does not exist, create it
     if(NOT (EXISTS ${outputdir}))
-      file(MAKE_DIRECTORY ${outputdir})
+      make_directory(${outputdir})
     endif()
 
     # If header already exists, skip symlinking/stub header creation
@@ -100,6 +100,11 @@
       continue()
     endif()
 
+    # Match external imported targets out
+    if(lib MATCHES "^(ns3::)?[^:]+::.+$")
+      continue()
+    endif()
+
     # check if the example depends on disabled modules
     remove_lib_prefix("${lib}" lib)
 
@@ -125,12 +130,13 @@
 #
 # DEPRECATED_HEADER_FILES = "list;of;deprecated;.h;files", copy won't get triggered if DEPRECATED_HEADER_FILES isn't set
 # IGNORE_PCH = TRUE or FALSE, prevents the PCH from including undesired system libraries (e.g. custom GLIBC for DCE)
+# GENERATE_EXPORT_HEADER = TRUE or FALSE, auto-generate a header file to set *_EXPORT symbols for Windows builds
 # MODULE_ENABLED_FEATURES = "list;of;enabled;features;for;this;module" (used by fd-net-device)
 # cmake-format: on
 
 function(build_lib)
   # Argument parsing
-  set(options IGNORE_PCH)
+  set(options IGNORE_PCH GENERATE_EXPORT_HEADER)
   set(oneValueArgs LIBNAME)
   set(multiValueArgs
       SOURCE_FILES
@@ -167,6 +173,35 @@
   # Set alias
   add_library(ns3::${BLIB_LIBNAME} ALIAS ${BLIB_LIBNAME})
 
+  set(export_file)
+  if(${BLIB_GENERATE_EXPORT_HEADER})
+    include(GenerateExportHeader)
+    string(TOUPPER "${BLIB_LIBNAME}" uppercase_libname)
+    string(
+      CONCAT force_undef_export
+             "\n// Undefine the *_EXPORT symbols for non-Windows based builds"
+             "\n#ifndef NS_MSVC"
+             "\n#undef ${uppercase_libname}_EXPORT"
+             "\n#define ${uppercase_libname}_EXPORT"
+             "\n#undef ${uppercase_libname}_NO_EXPORT"
+             "\n#define ${uppercase_libname}_NO_EXPORT"
+             "\n#endif"
+    )
+    set(export_file ${CMAKE_HEADER_OUTPUT_DIRECTORY}/${BLIB_LIBNAME}-export.h)
+
+    generate_export_header(
+      ${BLIB_LIBNAME} EXPORT_FILE_NAME ${export_file}
+      CUSTOM_CONTENT_FROM_VARIABLE force_undef_export
+    )
+
+    # In case building on Visual Studio
+    if(${MSVC})
+      target_compile_definitions(
+        ${BLIB_LIBNAME} PRIVATE ${BLIB_LIBNAME}_EXPORTS
+      )
+    endif()
+  endif()
+
   # Reuse PCH
   if(${PRECOMPILE_HEADERS_ENABLED} AND (NOT ${BLIB_IGNORE_PCH}))
     target_precompile_headers(${BLIB_LIBNAME} REUSE_FROM stdlib_pch)
@@ -177,11 +212,14 @@
     ${BLIB_LIBNAME}
     PROPERTIES
       PUBLIC_HEADER
-      "${BLIB_HEADER_FILES};${BLIB_DEPRECATED_HEADER_FILES};${CMAKE_HEADER_OUTPUT_DIRECTORY}/${BLIB_LIBNAME}-module.h"
+      "${BLIB_HEADER_FILES};${BLIB_DEPRECATED_HEADER_FILES};${CMAKE_HEADER_OUTPUT_DIRECTORY}/${BLIB_LIBNAME}-module.h;${export_file}"
       PRIVATE_HEADER "${BLIB_PRIVATE_HEADER_FILES}"
-      RUNTIME_OUTPUT_DIRECTORY ${CMAKE_LIBRARY_OUTPUT_DIRECTORY} # set output
-                                                                 # directory for
-                                                                 # DLLs
+      # set output directory for DLLs
+      RUNTIME_OUTPUT_DIRECTORY ${CMAKE_LIBRARY_OUTPUT_DIRECTORY}
+      RUNTIME_OUTPUT_DIRECTORY_DEBUG ${CMAKE_LIBRARY_OUTPUT_DIRECTORY}
+      RUNTIME_OUTPUT_DIRECTORY_RELEASE ${CMAKE_LIBRARY_OUTPUT_DIRECTORY}
+      RUNTIME_OUTPUT_DIRECTORY_RELWITHDEBINFO ${CMAKE_LIBRARY_OUTPUT_DIRECTORY}
+      RUNTIME_OUTPUT_DIRECTORY_MINSIZEREL ${CMAKE_LIBRARY_OUTPUT_DIRECTORY}
   )
 
   if(${NS3_CLANG_TIMETRACE})
@@ -228,6 +266,10 @@
     "${BLIB_LIBNAME}" "${BLIB_IGNORE_PCH}" "${FOLDER}" "${BLIB_TEST_SOURCES}"
   )
 
+  if(${MSVC})
+    target_link_options(${lib${BLIB_LIBNAME}} PUBLIC "/OPT:NOREF")
+  endif()
+
   # Handle package export
   install(
     TARGETS ${BLIB_LIBNAME}
@@ -325,7 +367,7 @@
 
 function(build_lib_export_definitions_as_interface_definitions libname)
   get_target_property(target_definitions ${libname} COMPILE_DEFINITIONS)
-  if(${target_definitions} STREQUAL "target_definitions-NOTFOUND")
+  if("${target_definitions}" STREQUAL "target_definitions-NOTFOUND")
     set(target_definitions)
   endif()
   get_directory_property(dir_definitions COMPILE_DEFINITIONS)
@@ -410,7 +452,10 @@
 function(separate_ns3_from_non_ns3_libs libname libraries_to_link
          ns_libraries_to_link non_ns_libraries_to_link
 )
-  set(non_ns_libs ${CMAKE_THREAD_LIBS_INIT})
+  set(non_ns_libs)
+  if(DEFINED CMAKE_THREAD_LIBS_INIT)
+    list(APPEND non_ns_libs ${CMAKE_THREAD_LIBS_INIT})
+  endif()
   set(ns_libs)
   foreach(library ${libraries_to_link})
     remove_lib_prefix("${library}" module_name)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/build-support/custom-modules/ns3-output-directory.cmake ns-3.44/build-support/custom-modules/ns3-output-directory.cmake
--- ns-3.43/build-support/custom-modules/ns3-output-directory.cmake	2024-10-09 16:41:09.764655400 -0700
+++ ns-3.44/build-support/custom-modules/ns3-output-directory.cmake	2025-03-09 16:55:49.231370400 -0700
@@ -6,6 +6,40 @@
 
 # This is where we define where executables, libraries and headers will end up
 
+# Test if python is available
+execute_process(
+  COMMAND ${CMAKE_COMMAND} -E env python3 -c "exit(0)"
+  RESULT_VARIABLE PYTHON_AVAILABLE
+)
+
+function(make_directory directory_path)
+  if("${PYTHON_AVAILABLE}" EQUAL 0)
+    # In case python is available, check if we have write permissions on
+    # directory_path before trying to create it
+    get_filename_component(parent ${directory_path} DIRECTORY)
+    get_filename_component(grandparent ${parent} DIRECTORY)
+    execute_process(
+      COMMAND
+        ${CMAKE_COMMAND} -E env python3 -c
+        "import os; exit(0 if sum(map(lambda x: os.path.exists(x) and os.access(x, os.W_OK), ['${parent}', '${grandparent}'])) else 1)"
+      RESULT_VARIABLE RESULT
+    )
+    if(NOT (${RESULT} EQUAL 0))
+      message(
+        FATAL_ERROR
+          "Failed to create directory: ${directory_path}. Check for write permissions."
+      )
+    endif()
+  else()
+    # In case python is not available, warn users
+    message(
+      WARNING
+        "Python3 executable was not found and write permissions won't be checked. Build may break for file permission issues."
+    )
+  endif()
+  file(MAKE_DIRECTORY ${directory_path})
+endfunction()
+
 if("${NS3_OUTPUT_DIRECTORY}" STREQUAL "")
   message(STATUS "Using default output directory ${PROJECT_SOURCE_DIR}/build")
   set(CMAKE_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR}/build) # default output
@@ -25,34 +59,21 @@
                  "${absolute_ns3_output_directory}"
   )
 
-  if(NOT (EXISTS ${absolute_ns3_output_directory}))
-    message(
-      STATUS
-        "User-defined output directory \"${NS3_OUTPUT_DIRECTORY}\" doesn't exist. Trying to create it"
-    )
-    file(MAKE_DIRECTORY ${absolute_ns3_output_directory})
-    if(NOT (EXISTS ${absolute_ns3_output_directory}))
-      message(
-        FATAL_ERROR
-          "User-defined output directory \"${absolute_ns3_output_directory}\" could not be created. "
-          "Try changing the value of NS3_OUTPUT_DIRECTORY"
-      )
-    endif()
-
-    # If this directory is not inside the ns-3-dev folder, alert users tests may
-    # break
-    if(NOT ("${absolute_ns3_output_directory}" MATCHES "${PROJECT_SOURCE_DIR}"))
-      message(
-        WARNING
-          "User-defined output directory \"${absolute_ns3_output_directory}\" is outside "
-          " of the ns-3 directory ${PROJECT_SOURCE_DIR}, which will break some tests"
-      )
-    endif()
-  endif()
   message(
     STATUS
-      "User-defined output directory \"${absolute_ns3_output_directory}\" will be used"
+      "Creating user-defined output directory \"${NS3_OUTPUT_DIRECTORY}\". In case it fails, try changing the value of NS3_OUTPUT_DIRECTORY or check the directory permissions."
   )
+  make_directory(${absolute_ns3_output_directory})
+
+  # If this directory is not inside the ns-3-dev folder, alert users tests may
+  # break
+  if(NOT ("${absolute_ns3_output_directory}" MATCHES "${PROJECT_SOURCE_DIR}"))
+    message(
+      WARNING
+        "User-defined output directory \"${absolute_ns3_output_directory}\" is outside "
+        " of the ns-3 directory ${PROJECT_SOURCE_DIR}, which will break some tests"
+    )
+  endif()
   set(CMAKE_OUTPUT_DIRECTORY ${absolute_ns3_output_directory})
 endif()
 
@@ -68,4 +89,6 @@
 set(THIRD_PARTY_DIRECTORY ${PROJECT_SOURCE_DIR}/3rd-party)
 set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
 link_directories(${CMAKE_OUTPUT_DIRECTORY}/${libdir})
-file(MAKE_DIRECTORY ${CMAKE_OUTPUT_DIRECTORY})
+make_directory(${CMAKE_OUTPUT_DIRECTORY})
+make_directory(${CMAKE_LIBRARY_OUTPUT_DIRECTORY})
+make_directory(${CMAKE_HEADER_OUTPUT_DIRECTORY})
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/build-support/custom-modules/ns3-platform-support.cmake ns-3.44/build-support/custom-modules/ns3-platform-support.cmake
--- ns-3.43/build-support/custom-modules/ns3-platform-support.cmake	2024-10-09 16:41:09.764655400 -0700
+++ ns-3.44/build-support/custom-modules/ns3-platform-support.cmake	2025-03-09 16:55:49.231370400 -0700
@@ -50,6 +50,7 @@
   set(CMAKE_FIND_APPBUNDLE "LAST")
 endif()
 
+set(cat_command cat)
 if(WIN32)
   set(NS3_PRECOMPILE_HEADERS OFF
       CACHE BOOL "Precompile module headers to speed up compilation" FORCE
@@ -59,19 +60,30 @@
   # requires this definition
   # https://docs.microsoft.com/en-us/cpp/c-runtime-library/math-constants?view=vs-2019
   add_definitions(/D_USE_MATH_DEFINES)
+  set(cat_command type) # required until we move to CMake >= 3.18
 endif()
 
-set(cat_command cat)
-
 if(CMAKE_XCODE_BUILD_SYSTEM)
   set(XCODE True)
 else()
   set(XCODE False)
 endif()
 
-if(${XCODE})
+if("${CMAKE_CXX_COMPILER_ID}" MATCHES "MSVC" OR "${CMAKE_CXX_SIMULATE_ID}"
+                                                MATCHES "MSVC"
+)
+  set(MSVC True)
+  set(NS3_INT64X64 "CAIRO" CACHE STRING "Int64x64 implementation" FORCE)
+else()
+  set(MSVC False)
+endif()
+
+if(${MSVC} OR ${XCODE})
   # Prevent multi-config generators from placing output files into per
   # configuration directory
+  if(NOT (DEFINED CMAKE_CONFIGURATION_TYPES))
+    set(CMAKE_CONFIGURATION_TYPES DEBUG RELEASE RELWITHDEBINFO MINSIZEREL)
+  endif()
   foreach(OUTPUTCONFIG ${CMAKE_CONFIGURATION_TYPES})
     string(TOUPPER ${OUTPUTCONFIG} OUTPUTCONFIG)
     set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_${OUTPUTCONFIG}
@@ -83,5 +95,23 @@
     set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_${OUTPUTCONFIG}
         ${CMAKE_ARCHIVE_OUTPUT_DIRECTORY}
     )
-  endforeach()
+  endforeach(OUTPUTCONFIG CMAKE_CONFIGURATION_TYPES)
+endif()
+
+if(${MSVC})
+  set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
+
+  # Enable exceptions
+  add_definitions(/EHs)
+
+  # Account for lack of valgrind and binary compatibility restrictions on
+  # Windows https://github.com/microsoft/STL/wiki/Changelog#vs-2022-1710
+  add_compile_definitions(
+    __WIN32__ NVALGRIND _DISABLE_CONSTEXPR_MUTEX_CONSTRUCTOR
+    _CRT_SECURE_NO_WARNINGS NS_MSVC NOMINMAX
+  )
+
+  # Allow unresolved symbols as in most cases they are simply in other ns-3
+  # libraries
+  add_link_options("/FORCE:UNRESOLVED")
 endif()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/build-support/custom-modules/ns3-vcpkg-hunter.cmake ns-3.44/build-support/custom-modules/ns3-vcpkg-hunter.cmake
--- ns-3.43/build-support/custom-modules/ns3-vcpkg-hunter.cmake	2024-10-09 16:41:09.764655400 -0700
+++ ns-3.44/build-support/custom-modules/ns3-vcpkg-hunter.cmake	2025-03-09 16:55:49.231370400 -0700
@@ -62,7 +62,7 @@
     )
   endif()
 
-  if(DEFINED MSVC)
+  if(${MSVC})
     message(FATAL_ERROR "vcpkg: Visual Studio is unsupported")
   else()
     # Check if required packages are installed (unzip curl tar)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/build-support/custom-modules/ns3-versioning.cmake ns-3.44/build-support/custom-modules/ns3-versioning.cmake
--- ns-3.43/build-support/custom-modules/ns3-versioning.cmake	2024-10-09 16:41:09.764655400 -0700
+++ ns-3.44/build-support/custom-modules/ns3-versioning.cmake	2025-03-09 16:55:49.231370400 -0700
@@ -6,7 +6,9 @@
 function(check_git_repo_has_ns3_tags HAS_TAGS GIT_VERSION_TAG)
   execute_process(
     COMMAND ${GIT} describe --tags --abbrev=0 --match ns-3.[0-9]*
-    OUTPUT_VARIABLE GIT_TAG_OUTPUT ERROR_QUIET
+    WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
+    OUTPUT_VARIABLE GIT_TAG_OUTPUT
+    ERROR_QUIET
   )
 
   # Result will be empty in case of a shallow clone or no git repo
@@ -35,7 +37,7 @@
 )
   execute_process(
     COMMAND ${GIT} describe --tags --dirty --long
-    OUTPUT_VARIABLE GIT_TAG_OUTPUT
+    WORKING_DIRECTORY ${PROJECT_SOURCE_DIR} OUTPUT_VARIABLE GIT_TAG_OUTPUT
   )
 
   string(REPLACE "\r" "" GIT_TAG_OUTPUT ${GIT_TAG_OUTPUT}) # remove CR (carriage
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/build-support/macros-and-definitions.cmake ns-3.44/build-support/macros-and-definitions.cmake
--- ns-3.43/build-support/macros-and-definitions.cmake	2024-10-09 16:41:09.764655400 -0700
+++ ns-3.44/build-support/macros-and-definitions.cmake	2025-03-09 16:55:49.231370400 -0700
@@ -212,7 +212,7 @@
 
   # Set warning level and warning as errors
   if(${NS3_WARNINGS})
-    if(DEFINED MSVC)
+    if(${MSVC})
       add_compile_options(/W3) # /W4 = -Wall + -Wextra
       if(${NS3_WARNINGS_AS_ERRORS})
         add_compile_options(/WX)
@@ -259,7 +259,8 @@
 
   if(${NS3_CLANG_TIDY})
     find_program(
-      CLANG_TIDY NAMES clang-tidy clang-tidy-14 clang-tidy-15 clang-tidy-16
+      CLANG_TIDY NAMES clang-tidy clang-tidy-15 clang-tidy-16 clang-tidy-17
+                       clang-tidy-18 clang-tidy-19
     )
     if("${CLANG_TIDY}" STREQUAL "CLANG_TIDY-NOTFOUND")
       message(FATAL_ERROR "Clang-tidy was not found")
@@ -540,7 +541,9 @@
     if(${SQLite3_FOUND})
       set(ENABLE_SQLITE True)
       add_definitions(-DHAVE_SQLITE3)
-      include_directories(${SQLite3_INCLUDE_DIRS})
+      if(NOT ${NS3_FORCE_LOCAL_DEPENDENCIES})
+        include_directories(${SQLite3_INCLUDE_DIRS})
+      endif()
     endif()
   endif()
 
@@ -554,7 +557,9 @@
       set(ENABLE_EIGEN True)
       add_definitions(-DHAVE_EIGEN3)
       add_definitions(-DEIGEN_MPL2_ONLY)
-      include_directories(${EIGEN3_INCLUDE_DIR})
+      if(NOT ${NS3_FORCE_LOCAL_DEPENDENCIES})
+        include_directories(${EIGEN3_INCLUDE_DIR})
+      endif()
     else()
       set(ENABLE_EIGEN_REASON "Eigen was not found")
     endif()
@@ -582,7 +587,9 @@
               "GTK3 found with incompatible version ${GTK3_VERSION}"
           )
         else()
-          include_directories(${GTK3_INCLUDE_DIRS} ${HarfBuzz_INCLUDE_DIRS})
+          if(NOT ${NS3_FORCE_LOCAL_DEPENDENCIES})
+            include_directories(${GTK3_INCLUDE_DIRS} ${HarfBuzz_INCLUDE_DIRS})
+          endif()
         endif()
       endif()
 
@@ -609,7 +616,9 @@
       set(LIBXML2_FOUND_REASON "LibXML2 was not found")
     else()
       add_definitions(-DHAVE_LIBXML2)
-      include_directories(${LIBXML2_INCLUDE_DIR})
+      if(NOT ${NS3_FORCE_LOCAL_DEPENDENCIES})
+        include_directories(${LIBXML2_INCLUDE_DIR})
+      endif()
     endif()
   endif()
 
@@ -656,7 +665,9 @@
           set(CMAKE_INSTALL_RPATH "${DEVELOPER_DIR}" CACHE STRING "")
         endif()
       endif()
-      include_directories(${Python3_INCLUDE_DIRS})
+      if(NOT ${NS3_FORCE_LOCAL_DEPENDENCIES})
+        include_directories(${Python3_INCLUDE_DIRS})
+      endif()
     else()
       message(${HIGHLIGHTED_STATUS}
               "Python: development libraries were not found"
@@ -691,6 +702,12 @@
         set(ENABLE_PYTHON_BINDINGS_REASON
             "missing dependency: ${missing_packages}"
         )
+      elseif(${NS3_MPI})
+        message(
+          ${HIGHLIGHTED_STATUS}
+          "Bindings: python bindings disabled due to an incompatibility with the MPI module"
+        )
+        set(ENABLE_PYTHON_BINDINGS_REASON "incompatible module enabled: mpi")
       else()
         set(ENABLE_PYTHON_BINDINGS ON)
       endif()
@@ -816,12 +833,6 @@
     endif()
   endif()
 
-  # Process config-store-config
-  configure_file(
-    build-support/config-store-config-template.h
-    ${CMAKE_HEADER_OUTPUT_DIRECTORY}/config-store-config.h
-  )
-
   set(ENABLE_MPI FALSE)
   if(${NS3_MPI})
     find_package(MPI QUIET)
@@ -829,16 +840,21 @@
       message(FATAL_ERROR "MPI was not found.")
     else()
       message(STATUS "MPI was found.")
-      add_definitions(-DNS3_MPI)
-      include_directories(${MPI_CXX_INCLUDE_DIRS})
+      target_compile_definitions(MPI::MPI_CXX INTERFACE NS3_MPI)
       set(ENABLE_MPI TRUE)
     endif()
   endif()
 
+  # Use upstream boost package config with CMake 3.30 and above
+  if(POLICY CMP0167)
+    cmake_policy(SET CMP0167 NEW)
+  endif()
   mark_as_advanced(Boost_INCLUDE_DIR)
   find_package(Boost)
   if(${Boost_FOUND})
-    include_directories(${Boost_INCLUDE_DIRS})
+    if(NOT ${NS3_FORCE_LOCAL_DEPENDENCIES})
+      include_directories(${Boost_INCLUDE_DIRS})
+    endif()
     set(CMAKE_REQUIRED_INCLUDES ${Boost_INCLUDE_DIRS})
   endif()
 
@@ -850,7 +866,9 @@
     else()
       message(STATUS "GSL was found.")
       add_definitions(-DHAVE_GSL)
-      include_directories(${GSL_INCLUDE_DIRS})
+      if(NOT ${NS3_FORCE_LOCAL_DEPENDENCIES})
+        include_directories(${GSL_INCLUDE_DIRS})
+      endif()
     endif()
   endif()
 
@@ -1119,7 +1137,7 @@
   check_function_exists("getenv" "HAVE_GETENV")
 
   configure_file(
-    build-support/core-config-template.h
+    ${PROJECT_SOURCE_DIR}/build-support/core-config-template.h
     ${CMAKE_HEADER_OUTPUT_DIRECTORY}/core-config.h
   )
 
@@ -1316,19 +1334,14 @@
 
   # Netanim depends on ns-3 core, so we built it later
   if(${NS3_NETANIM})
-    include(FetchContent)
-    FetchContent_Declare(
-      netanim GIT_REPOSITORY https://gitlab.com/nsnam/netanim.git
-      GIT_TAG netanim-3.109
-    )
-    FetchContent_Populate(netanim)
-    file(COPY build-support/3rd-party/netanim-cmakelists.cmake
-         DESTINATION ${netanim_SOURCE_DIR}
-    )
-    file(RENAME ${netanim_SOURCE_DIR}/netanim-cmakelists.cmake
-         ${netanim_SOURCE_DIR}/CMakeLists.txt
+    include(ExternalProject)
+    ExternalProject_Add(
+      netanim_visualizer
+      GIT_REPOSITORY https://gitlab.com/nsnam/netanim.git
+      GIT_TAG netanim-3.110
+      BUILD_IN_SOURCE TRUE
+      CMAKE_ARGS -DCMAKE_INSTALL_PREFIX=${CMAKE_OUTPUT_DIRECTORY}
     )
-    add_subdirectory(${netanim_SOURCE_DIR} ${netanim_BINARY_DIR})
   endif()
 
   if(${NS3_FETCH_OPTIONAL_COMPONENTS})
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/build-support/test-files/test-contrib-dependency/contrib-source.cc ns-3.44/build-support/test-files/test-contrib-dependency/contrib-source.cc
--- ns-3.43/build-support/test-files/test-contrib-dependency/contrib-source.cc	2024-10-09 16:41:09.764655400 -0700
+++ ns-3.44/build-support/test-files/test-contrib-dependency/contrib-source.cc	2025-03-09 16:55:49.231370400 -0700
@@ -1,6 +1,6 @@
 #include "contrib-header.h"
 
-#include <ns3/simulator.h>
+#include "ns3/simulator.h"
 
 void
 testPrint()
